SystemOrganization addCategory: #'Casper-Core'!

Dictionary subclass: #PhClassModifierDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 20:43'!
at: key includes: value

	|set|
	
	self at: key ifPresent: [:aSet| aSet includes: value].
	^false.! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 23:26'!
at: key put: value

	|set|
	
	set := super at: key ifAbsent: [
		|s| 
		s:= Set new. 
		super at: key put: s. 
		s
	].
	set add: value.! !

!PhClassModifierDictionary methodsFor: 'removing' stamp: 'mcamp 10/8/2012 23:31'!
at: key remove: value

	|set|
	
	self at: key ifPresent: [:aSet| 
		aSet remove: value.
		aSet ifEmpty: [self removeKey: key].
	].! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/8/2012 21:06'!
atAll: keys put: value

	keys do:[:k| self at: k put: value].! !

!PhClassModifierDictionary methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:08'!
atAll: keys remove: value

	keys do:[:k| self at: k remove: value].! !

!PhClassModifierDictionary methodsFor: 'cleaning' stamp: 'mcamp 10/8/2012 20:33'!
cleanObsolete

	self keysDo: [:key| key isObsolete ifTrue:[self removeKey: key]].! !

!PhClassModifierDictionary methodsFor: 'accessing' stamp: 'mcamp 10/16/2012 04:06'!
getAllClassModifiers

	|classModifiers|
	
	classModifiers := Set new.
	
	self valuesDo: [:values| classModifiers addAll: values].
	^classModifiers.! !

Object subclass: #PhAbstractSourceBuilder
	instanceVariableNames: 'methodDefinition source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
adviceVar

	^'phAdvice'.! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
afterAdvice

	^'"After Advice"'! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:22'!
allTmpVar

	^self aroundVar, ' ', self contextVar, ' ', self originalVar, ' ', self senderVar, ' ', self argsVar, ' ', self receiverVar, ' ',self returnVar, ' ', self wrapperVar, ' ', self adviceVar.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
argsVar
	
	^'phArgsVar'! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
aroundAdvice

	^'"Around Advice - in reverse order of execution"'! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
aroundVar

	^'phAroundAdvice'.! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
beforeAdvice

	^'"Before Advice"'! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
beginAutogenerate

	^'"Begin Autogenerated Casper code"'! !

!PhAbstractSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 1/1/2013 23:13'!
casperCategory

	^ 'casper autogenerated'.! !

!PhAbstractSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 1/1/2013 23:13'!
casperClassModifiedCategory

	^ 'casper class modifiers'.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
contextVar

	^'phCtx'.! !

!PhAbstractSourceBuilder class methodsFor: 'class initialization' stamp: 'mcamp 1/6/2013 20:09'!
createFromMethodDefinition: aMethodDefinition source: aSource

	|n|
	
	aMethodDefinition isSpecialSelector 
		ifTrue: [n := PhSpecialSourceBuilder new]
		ifFalse: [n := PhSourceBuilder new].
	n source: aSource; methodDefinition: aMethodDefinition.  
	^n.! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
endAutogenerate

	^ '"End Autogenerated Casper code"'! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:11'!
explanationComment: methodName

	^' "This method has been modified by Casper. The original implementation can be found in ',methodName,'" '.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
originalVar

	^'phOriginalMethod'.! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:12'!
preProcessing

	^'"Casper pre-processing"'! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
receiverVar

	^'phReceiver'.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:15'!
returnVar

	^'phReturn'.! !

!PhAbstractSourceBuilder class methodsFor: 'parsing' stamp: 'mcamp 1/1/2013 23:15'!
selectorOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: aClass) selector.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:16'!
senderVar

	^'phSender'.! !

!PhAbstractSourceBuilder class methodsFor: 'automessages' stamp: 'mcamp 1/1/2013 23:12'!
startExecution

	^'"Execution"'! !

!PhAbstractSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 1/1/2013 23:23'!
textOfContext: context

	|text|
	
	text := Text new.
	
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, self contextVar, ' := PhContext new.', String cr.
	context isEmptyOrNil ifFalse:[
		context do:[:ctx| 
			ctx == #receiver ifTrue:[text append: String tab, self contextVar, ' receiver: self.', String cr].
			ctx == #sender ifTrue:[text append: String tab, self contextVar, ' sender: thisContext sender receiver.', String cr].
			ctx == #arguments ifTrue: [text append: String tab, self contextVar, ' arguments: ', self argsVar,'.', String cr].
			ctx == #selector ifTrue: [text append: String tab, self contextVar, ' selector: thisContext method selector.', String cr].
		]	
	].
	
	^text.! !

!PhAbstractSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 1/1/2013 23:24'!
textOfContextAtAround: advice withIndex: index

	|text ctxText context ctxTextNext|
	
	context := advice pointcut context.
	
	text := Text new.
	ctxText := self contextVar,index asString.
	ctxTextNext := self contextVar,(index+1) asString.
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, ctxText, ' := ', self contextVar, ' copy.', String cr.
	context isEmptyOrNil ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, self contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr].
		((context includes: #proceed) or:[advice hasConditionalPointcut])
			ifTrue:[
				text append:  String tab, ctxText, ' proceedBlock: ', self aroundVar, (index + 1) asString, '.', String cr.
				text append:  String tab, ctxText, ' nextContext: ',ctxTextNext, '.', String cr.
			]
	].
	
	
	^text.! !

!PhAbstractSourceBuilder class methodsFor: 'context text' stamp: 'mcamp 1/1/2013 23:30'!
textOfContextAtFirstAround: advice withIndex: index

	|text ctxText context|
	
	context := advice pointcut context.
	
	text := Text new.
	ctxText := self contextVar,index asString.
	"eliminar ifelse"
	self flag:#refactoring.
	text append: String tab, ctxText, ' := ', self contextVar, ' copy.', String cr.
	context isEmptyOrNil ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, self contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr].
		((context includes: #proceed) or: [advice hasConditionalPointcut])
			ifTrue:[
				text append:  String tab, ctxText, ' proceedBlock: ', self originalVar, '.', String cr.
				text append:  String tab, ctxText, ' isOriginal: true.', String cr.
				text append:  String tab, ctxText, ' originalArgs: ', self argsVar,'.',String cr.
			]
	].
	
	
	^text.! !

!PhAbstractSourceBuilder class methodsFor: 'generated method' stamp: 'mcamp 1/1/2013 23:14'!
toAppendOnSelector

	|counter|
	counter := PhAspectWeaver getCounterAndAddOne.
	^ 'casper', counter asString.! !

!PhAbstractSourceBuilder class methodsFor: 'tmpVar' stamp: 'mcamp 1/1/2013 23:16'!
wrapperVar

	^'phWrapper'.! !

!PhAbstractSourceBuilder methodsFor: 'private' stamp: 'mcamp 1/3/2013 02:37'!
argumentsOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: methodDefinition wrappedClass) arguments collect: [:arg| arg key].
	! !

!PhAbstractSourceBuilder methodsFor: 'build context' stamp: 'mcamp 1/1/2013 23:31'!
buildAdviceContext: advice at: index

	|text context |
	
	text := Text new.
	context := advice pointcut context.
	"eliminar ifelse"
	self flag:#refactoring.
	context isEmptyOrNil 
	ifTrue:[
		text append: String tab, self class contextVar, ' thisAdvice: nil.', String cr.
	]
	ifFalse:[
		(context includes: #thisAdvice)
			ifTrue:[text append: String tab, self class contextVar, ' thisAdvice: ', (self thisAdviceSource: advice at: index),'.',String cr]
			ifFalse:[text append: String tab, self class contextVar, ' thisAdvice: nil.', String cr].
	].
	
	^text.! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/1/2013 23:54'!
buildAdviceOrSend: advice at: index

	|text|
	
	text := Text new.
	(advice isSend or: [advice hasConditionalPointcut ])
		ifTrue:[text append: String tab, self class adviceVar , ' := ',(self thisAdviceSource: advice at: index),'.',String cr.].
	advice hasConditionalPointcut ifTrue:[
		text append: String tab, '(', self class adviceVar,' shouldExecuteOn: ', self class contextVar, ')', String cr.
		text append: String tab, String tab,  'ifTrue:[', String cr.
		text append: String tab, String tab.
	].
	
	advice isSend 
		ifFalse: [ 
			text append: (String tab, advice advice asString, ' value: ', self class contextVar,'.', String cr) asText
		]
		ifTrue: [
			advice objectSend isBlock
				ifTrue:[
					text append: String tab, '(', self class adviceVar, ' objectSend value: ', self class contextVar ,')', 'perform: #', advice selectorSend,' with: ', self class contextVar,'.', String cr.
				]
				ifFalse:[
					text append: String tab, self class adviceVar, ' objectSend perform: #', advice selectorSend,' with: ', self class contextVar,'.', String cr.
				].
		].
	
	advice hasConditionalPointcut 
		ifTrue:[text append: String tab, String tab, '].', String cr].
	
	^text. ! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/1/2013 23:55'!
buildAdviceOrSendToAround: advice at: index withContext: aCtx

	|text|
	
	text := Text new.
	(advice hasConditionalPointcut or: [advice isSend])
		ifTrue:[
			text append: String tab, self class adviceVar , ' := ',(self thisAdviceSource: advice at: index), '.',String cr.
		].
	text append: String tab, self class aroundVar,index asString, ' := ', String cr.
	advice hasConditionalPointcut ifTrue:[
		text append: String tab, String tab,  '(', self class adviceVar ,' shouldExecuteOn: ', aCtx, ')',String cr.
		text append: String tab, String tab, String tab,  'ifTrue:[',String cr.
		text append: String tab, String tab, String tab.
	].

	advice isSend 
		ifFalse: [text append: String tab, advice advice asString asText]
		ifTrue:[
		advice objectSend isBlock
			ifTrue:[
				text append: String tab, '[:phInnerAroundAdvice| [:ctx| (phInnerAroundAdvice objectSend value: ctx) perform: #', advice selectorSend,' with: ctx ] ] value: ', self class adviceVar.
			]
			ifFalse:[
				text append:  String tab, '[:phInnerAroundAdvice| [:ctx| phInnerAroundAdvice objectSend perform: #', advice selectorSend,' with: ctx ] ] value: ', self class adviceVar.
			].
		].
	
	advice hasConditionalPointcut 
	ifTrue:[
		text append: String cr, String tab, String tab, String tab, ']',String cr.
		text append: String tab,String tab, String tab, 'ifFalse:[',String cr.
		text append: String tab,String tab, String tab, String tab,'[:ctx| ctx proceed].', String cr.
		text append: String tab,String tab, String tab, '].',String cr.
	]
	ifFalse: [
		text append: '.',String cr.
	].

	^text.! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/3/2013 03:18'!
buildAfterSource: advices

	advices isEmpty 
		ifFalse:[ |index|
			source append: String cr.
			source append: String tab, self class afterAdvice ,String cr.
			index := 1.
			advices do:[:adv| 
				source append: (self buildAdviceContext: adv at: index).
				source append: (self buildAdviceOrSend: adv at: index).
				index := index + 1.
			].
		]
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/3/2013 02:38'!
buildArguments

	|text args|
	text := Text new.
	text append: String tab,self class argsVar, ' := OrderedCollection new.', String cr.
	
	args := self argumentsOfSource: source class: methodDefinition wrappedClass.
	args isEmptyOrNil ifFalse:[
		text append: String tab, self class argsVar,String cr.
		args do:[:arg|
			text append: String tab, String tab,	 'add: ',arg, ';', String cr.
		].
		text at: (text size - 1) put: $..
		text append: String cr.
	].
	text append: String tab, self class argsVar, ':= ',self class argsVar,' asArray.', String cr.
	source append: text.! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/1/2013 23:55'!
buildAroundSource: advices

	advices isEmpty 
		ifFalse:[ | generatedText firstAdvice aroundText ctxText|
			
			generatedText := Text new.
				
			generatedText append: String tab, self class aroundAdvice ,String cr.
			generatedText append: String tab, self class senderVar, ' := thisContext sender receiver.', String cr.
			firstAdvice := true.
			
			"genero wrapper global para aroundAdvices"
			aroundText :=  self class aroundVar.
			ctxText := self class contextVar.
			generatedText append: String tab, aroundText, ' := [' , String cr.
			"2n variables temporales"
			generatedText append: String tab, '|'.
			(1 to: advices size ) reverse do: [ :index|
				generatedText append: ctxText,index asString,' ',aroundText,index asString,' '.
			].
			generatedText append: '|',String cr.
			generatedText append: String tab, ctxText,' thisAdvice: nil.', String cr.
			"genero advices"
			(1 to: advices size ) reverse do: [ :index|
				|lastAround|
				lastAround := index == advices size.
				"genero contexto"
				lastAround
					ifTrue:[
						generatedText append: (self class textOfContextAtFirstAround: (advices at: index ) withIndex: index).
					]
					ifFalse:[
						generatedText append: (self class textOfContextAtAround: (advices at: index ) withIndex: index).
					].
				"genero advice"
				generatedText append: (self buildAdviceOrSendToAround:(advices at: index) at: index withContext:  self class contextVar,index asString).
				

			].
			"primera ejecucion"
			generatedText append: String tab, aroundText, '1 value: ',ctxText,'1.',String cr.
			generatedText append: String tab, '].' , String cr.
			
			source append: generatedText.
		]! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/1/2013 23:55'!
buildBeforeSource: advices

	advices isEmpty 
		ifFalse:[ |generatedText index|
			
			generatedText := Text new.
			generatedText append: String tab, self class beforeAdvice ,String cr.
			index := 1.
			advices do:[:adv| 
				generatedText append: (self buildAdviceContext: adv at: index).
				generatedText append: (self buildAdviceOrSend: adv at: index).
				index := index + 1.
			].
			
			source append: generatedText.
		]! !

!PhAbstractSourceBuilder methodsFor: 'build context' stamp: 'mcamp 1/1/2013 23:55'!
buildCommonContext: contexts
	| generate|
	
	generate := Text new.
	
	generate 
		append: (self class textOfContext: contexts).
	source append: generate.
	
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:55'!
buildExecutionSource: isOriginalCall

	source append: String tab, self class startExecution ,String cr.
	source append: String tab, self class returnVar, ' := '.
	isOriginalCall 
		ifTrue:[source append: self class originalVar ,' value: ', self class argsVar,'.',String cr.]
		ifFalse:[source append: self class aroundVar ,' value.',String cr.].
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:55'!
buildFirstComment: aSelector
	| generate|
	
	generate := Text new.
	generate 
		append: String cr;
		append: (self class explanationComment: aSelector);
		append: String cr, String cr.
	source append: generate.
	
	! !

!PhAbstractSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 17:49'!
buildNewSelector: aSource

	^self subclassResponsibility 
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/3/2013 02:12'!
buildNewSelectorWithArgs: aCasperName

	^self subclassResponsibility ! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/6/2013 17:37'!
buildNewSource
	
	"first time, create casper method"
	self flag:#sacarLogica.
	self createCasperMethod.
	
	self cleanOriginalSource.
	self buildNewSelectorWithArgs: methodDefinition casperCounter.
	self buildFirstComment: methodDefinition casperSelector.
	self buildTempVar.
	self buildPreProcessing.
	self buildArguments.
	self buildCommonContext: methodDefinition commonContext.
	self buildBeforeSource: methodDefinition beforeAdvices.
	self buildOriginalCall: methodDefinition casperSelector.
	self buildAroundSource: methodDefinition aroundAdvices.
	self buildExecutionSource: methodDefinition aroundAdvices isEmptyOrNil.
	self buildAfterSource: methodDefinition afterAdvices.
	self buildReturnStatement.
	^source.
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:55'!
buildOriginalCall: casperSelector
	
	|generatedText|
	
	generatedText := Text new.
			
	generatedText append: String tab, self class originalVar, ' := ', String cr. 
	generatedText append: String tab, '[:args|', String cr. 
	generatedText append: String tab, self class receiverVar, ' perform: #', casperSelector,' withArguments: args.',String cr.
	generatedText append: String cr.
	generatedText append: String tab, '].', String cr.
	
	source append: generatedText.! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:55'!
buildOriginalSource
	
	|generatedText initIndex|
	
	generatedText := Text new.
	"this is wrong, just for testing porpuse, correct has to be after inst var if there are"
	self flag:#correctIndex.
	initIndex := source findString: String cr startingAt:1.
			
	generatedText append:String tab, self class beginAutogenerate ,String cr.
	generatedText append: String tab, self class originalVar, ' := [', String cr. 
	generatedText append: String tab, self class endAutogenerate , String cr.
	generatedText append: (source copyFrom: (initIndex + 1) to: source size).
	
	generatedText append: String cr.
	generatedText append:String tab, self class beginAutogenerate ,String cr.
	generatedText append: String tab, '].', String cr.
	generatedText append: String tab, self class endAutogenerate , String cr.
	
	^generatedText .! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:55'!
buildPreProcessing
	| generate|
	
	generate := Text new.
	generate 
		append: String tab, (self class preProcessing);
		append: String cr.
	source append: generate.
	
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 23:56'!
buildReturnStatement

	source append: String cr.
	source append: String tab, '^',self class returnVar.
	! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/3/2013 02:44'!
buildTempVar
	| generate|
	
	generate := Text new.
	generate 
		append: String tab, '|'; 
		append: self class allTmpVar;
		append: '|' , String cr.
	
	self flag: #takeAway.
	generate append: String tab, self class receiverVar, ' := self.',String cr.
	generate append: String tab, self class wrapperVar, ' := PhAspectWeaver getInstalledWrapperOf: ', methodDefinition wrappedClass asString , ' selector: #',methodDefinition selector asString,'.',String cr.
	source append: generate.
	
	! !

!PhAbstractSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 17:44'!
casperCounter

	methodDefinition casperCounter ifNil: [methodDefinition casperCounter:  self class toAppendOnSelector].! !

!PhAbstractSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 22:16'!
changeBackSource: aCasperSource
	|first last|
	
	first := aCasperSource findString: methodDefinition casperSelector startingAt: 0.
	last := first + (methodDefinition casperSelector size) - 1.
	
	"replace on casper source the selectors"
	aCasperSource replaceFrom: first to: last with: methodDefinition selector.
	
	source := aCasperSource.! !

!PhAbstractSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/1/2013 22:58'!
cleanOriginalSource

	|initIndex|

	initIndex := self getEndIndexOfSelector.
	source replaceFrom: (initIndex + 1) to: source size with: ''.! !

!PhAbstractSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 17:48'!
createCasperMethod

	|casperSource|
	casperSource := source copy.
	
	self buildNewSelector: casperSource.
	
	"compilar"
	methodDefinition casperSelector: (methodDefinition wrappedClass compile: casperSource classified: self class casperCategory)! !

!PhAbstractSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 02:14'!
getEndIndexOfSelector

	^self subclassResponsibility ! !

!PhAbstractSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/1/2013 22:46'!
methodDefinition
	^methodDefinition! !

!PhAbstractSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/1/2013 22:46'!
methodDefinition: aMethodDefinition
	methodDefinition := aMethodDefinition.! !

!PhAbstractSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 21:52'!
originalSourceCodeOfCasperSelector: casperSelector

	self changeBackSource: (methodDefinition wrappedClass methodDict at: casperSelector ) sourceCode asText.	
	^source.! !

!PhAbstractSourceBuilder methodsFor: 'private' stamp: 'mcamp 1/6/2013 18:07'!
selectorOfSource: aSource

	^(Parser new parse: aSource readStream class: methodDefinition wrappedClass) selector.
	! !

!PhAbstractSourceBuilder methodsFor: 'private' stamp: 'mcamp 1/3/2013 03:14'!
selectorOfSource: aSource class: aClass

	^(Parser new parse: aSource readStream class: methodDefinition wrappedClass) selector.
	! !

!PhAbstractSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/1/2013 22:48'!
source
	^ source! !

!PhAbstractSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/1/2013 22:47'!
source: aText
	source := aText.! !

!PhAbstractSourceBuilder methodsFor: 'build advices' stamp: 'mcamp 1/1/2013 23:56'!
thisAdviceSource: advice at: index
	^self class wrapperVar,' advices ', advice type, ' at:', index asString.! !

PhAbstractSourceBuilder subclass: #PhSourceBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 17:48'!
buildNewSelector: casperSource

	self casperCounter.
	casperSource at: 1 put: (casperSource at:1) asUppercase.
	casperSource prepend: methodDefinition casperCounter.! !

!PhSourceBuilder methodsFor: 'building source' stamp: 'mcamp 1/3/2013 02:35'!
buildNewSelectorWithArgs: aCasperName
	
	|arguments auxIndex|
	
	arguments := self argumentsOfSource: source class: methodDefinition wrappedClass.
	auxIndex := -1.
	arguments do:[:anArg|
		|index|
		auxIndex := source findString: ':' startingAt: auxIndex+1.
		index := source findString: anArg startingAt: auxIndex.
		source at: index put: (source at: index) asUppercase.
		source replaceFrom: index to: index - 1 with: aCasperName.	
	].! !

!PhSourceBuilder methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 02:36'!
getEndIndexOfSelector 

	|arguments|
	arguments := self argumentsOfSource: source class: methodDefinition wrappedClass.
	
	arguments isEmpty 
		ifTrue:[
			|s index|
			s := self selectorOfSource: source class: methodDefinition wrappedClass.
			index := source findString: s startingAt: 0.
			^index + s size - 1.
			
		]
		ifFalse:[
			|maxIndex lastArg numArgs|
			numArgs := arguments size.
			maxIndex := -1.
			[numArgs > 0 ] whileTrue:[
				maxIndex := source findString: ':' startingAt: maxIndex+1.
				numArgs := numArgs - 1.
			].
		
			lastArg := arguments last.
			maxIndex := source findString: lastArg startingAt: maxIndex.
			maxIndex := maxIndex + lastArg size - 1.
			^maxIndex.
		]! !

PhAbstractSourceBuilder subclass: #PhSpecialSourceBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhSpecialSourceBuilder class methodsFor: 'as yet unclassified' stamp: 'mcamp 1/6/2013 18:50'!
separator

 	^$c! !

!PhSpecialSourceBuilder methodsFor: 'casper method' stamp: 'mcamp 1/6/2013 20:25'!
buildNewSelector: casperSource
	|sel index newSel lastIndex|	

	self casperCounter.
	
	newSel := Text new.
	sel := self selectorOfSource: casperSource.
	index := casperSource findString: sel startingAt: 0.
	
	newSel append: methodDefinition casperCounter.
	
	sel do:[:aChar| 
		"append separator"
		newSel append: self class separator.
		newSel append: aChar asInteger asString.
	].
	
	newSel append: ': '.
	
	"change sel for newSel on source".
	lastIndex := index + sel size - 1.
	casperSource replaceFrom: index to: lastIndex with: newSel.
	! !

!PhSpecialSourceBuilder methodsFor: 'build source' stamp: 'mcamp 1/6/2013 17:33'!
buildNewSelectorWithArgs: aCasperName
	
	|arguments index arg|
	
	arguments := self argumentsOfSource: source class: methodDefinition wrappedClass.
	
	arg := arguments first.
	
	index := source findString: arg startingAt: 0.
	
	"put casperName at argument."
	source replaceFrom: index to: index - 1 with: aCasperName.! !

!PhSpecialSourceBuilder methodsFor: 'accesing' stamp: 'mcamp 1/6/2013 17:27'!
getEndIndexOfSelector 

	|arguments arg index|
	arguments := self argumentsOfSource: source class: methodDefinition wrappedClass.
	"on special selectors, only have one arguments "
	arg := arguments first.
	
	index := source findString: arg startingAt: 0.
	index := index + arg size - 1.
	^index.! !

Object subclass: #PhAdvice
	instanceVariableNames: 'type advice pointcut objectSend selectorSend isSend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
after: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #after.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
after: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #after.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
around: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #around! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
around: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #around.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 8/29/2012 23:12'!
before: aPC advice: aBlock
	^self new pointcut: aPC; advice: aBlock; type: #before.! !

!PhAdvice class methodsFor: 'instance creation' stamp: 'mcamp 9/24/2012 04:25'!
before: aPC send: aSymbol to: anObject 
	^self new pointcut: aPC; send: aSymbol to: anObject; type: #before.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 04:51'!
acceptCFlow: smContext

	^self pointcut isActivateOnCflowOf: smContext.! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
advice
	^ advice! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:26'!
advice: aBlock
	isSend := false.
	advice := aBlock.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:25'!
hasCFlowPointcut

	^pointcut isCflowPointcut.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:01'!
hasConditionalPointcut

	^pointcut isConditional.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 10/22/2012 21:15'!
hasIfPointcut

	^pointcut hasIfBlock.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:00'!
isAfter

	^type =#after.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 02:59'!
isAround

	^type =#around.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:00'!
isBefore

	^type =#before.! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
isSend
	^ isSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
objectSend
	^ objectSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
objectSend: anObject
	objectSend := anObject! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
pointcut
	^ pointcut! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:27'!
pointcut: aPointcut
	pointcut := aPointcut! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 9/28/2012 00:02'!
selectorSend
	^ selectorSend! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 10/18/2012 02:28'!
selectorSend: aSelector
	selectorSend := aSelector! !

!PhAdvice methodsFor: 'send' stamp: 'mcamp 10/18/2012 02:28'!
send: aSymbol to: anObjectOrBlock

	isSend := true.
	objectSend := anObjectOrBlock.
	selectorSend := aSymbol.! !

!PhAdvice methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:21'!
shouldExecuteOn: aCtx

	|shouldExecute|
	
	shouldExecute := true.
	self hasIfPointcut ifTrue:[
		shouldExecute := pointcut ifBlock value: aCtx.
	].

	shouldExecute ifFalse: [^false].
	
	 self hasCFlowPointcut ifTrue:[
		shouldExecute := self acceptCFlow: thisContext.
	].
	^shouldExecute.! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 8/29/2012 23:09'!
type
	^ type! !

!PhAdvice methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:28'!
type: aSymbol
	type := aSymbol! !

Object subclass: #PhAdviceGroup
	instanceVariableNames: 'beforeAdvices aroundAdvices afterAdvices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAdvice: advice.

	advice type == #before ifTrue:[self addBeforeAdvice: advice].
	advice type == #after ifTrue:[self addAfterAdvice: advice].
	advice type == #around ifTrue:[self addAroundAdvice: advice].! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:51'!
addAdvices: advices.

	advices do: [:adv| self addAdvice: adv].! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAfterAdvice: advice

	afterAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addAroundAdvice: advice

	aroundAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:50'!
addBeforeAdvice: advice

	beforeAdvices add: advice.! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
after

	^afterAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
afterAdvices
	^ afterAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
afterAdvices: aCollection
	afterAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 12:39'!
allAdvices

	|collection|
	
	collection := OrderedCollection new.
	collection addAll: afterAdvices;
				addAll: beforeAdvices;
				addAll: aroundAdvices.
	^collection.! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
around

	^aroundAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
aroundAdvices
	^ aroundAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
aroundAdvices: aCollection
	aroundAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:31'!
before

	^beforeAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 9/25/2012 02:01'!
beforeAdvices
	^ beforeAdvices! !

!PhAdviceGroup methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:30'!
beforeAdvices: aCollection
	beforeAdvices := aCollection! !

!PhAdviceGroup methodsFor: 'initialize-release' stamp: 'mcamp 9/28/2012 00:46'!
initialize

	super initialize.
	beforeAdvices := OrderedCollection new.
	afterAdvices := OrderedCollection new.
	aroundAdvices := OrderedCollection new.
	! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 10/18/2012 02:31'!
removeAdvice: anAdvice

	anAdvice type == #before ifTrue:[self removeBeforeAdvice: anAdvice].
	anAdvice type == #after ifTrue:[self removeAfterAdvice: anAdvice].
	anAdvice type == #around ifTrue:[self removeAroundAdvice: anAdvice].! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 03:01'!
removeAdvices: listAdvices

	listAdvices do: [:adv| self removeAdvice: adv].! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:08'!
removeAfterAdvice: anAdvice

	afterAdvices remove: anAdvice.! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:08'!
removeAroundAdvice: anAdvice

	aroundAdvices remove: anAdvice.! !

!PhAdviceGroup methodsFor: 'removing' stamp: 'mcamp 9/28/2012 01:07'!
removeBeforeAdvice: anAdvice

	beforeAdvices remove: anAdvice.! !

Object subclass: #PhAspect
	instanceVariableNames: 'adviceCollection installed onWrappers classModifierCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAspect methodsFor: 'adding' stamp: 'mcamp 9/3/2012 21:45'!
add: anAdvice
	self adviceCollection add: anAdvice.! !

!PhAspect methodsFor: 'adding' stamp: 'mcamp 10/4/2012 04:00'!
addClassModifier: aCM
	classModifierCollection add: aCM.! !

!PhAspect methodsFor: 'adding' stamp: 'mcamp 9/4/2012 01:41'!
addWrapper: aWrapper

	onWrappers add: aWrapper! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
adviceCollection
	^ adviceCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:43'!
adviceCollection: aCollection
	adviceCollection := aCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 02:02'!
classModifierCollection
	^ classModifierCollection! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:45'!
classModifierCollection: aCollection
	classModifierCollection := aCollection! !

!PhAspect methodsFor: 'testing' stamp: 'mcamp 10/4/2012 01:49'!
hasClassModifier

	^ classModifierCollection isEmptyOrNil not! !

!PhAspect methodsFor: 'initialize-release' stamp: 'mcamp 10/3/2012 03:36'!
initialize
	adviceCollection := OrderedCollection new.
	classModifierCollection := OrderedCollection new.
	installed := false.
	onWrappers := Set new.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 9/3/2012 21:07'!
install
	PhAspectWeaver installAspect: self.
	self installed: true.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 10/5/2012 01:01'!
installClassModifiers

	self classModifierCollection do:[:aCM|	
		aCM install.
	]! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
installed
	^ installed! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 8/30/2012 00:09'!
installed: anObject
	installed := anObject! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 9/4/2012 01:17'!
onWrappers
	^ onWrappers! !

!PhAspect methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 02:45'!
onWrappers: aSet
	onWrappers := aSet! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 8/30/2012 00:42'!
removeAdvice: anAdvice
	self adviceCollection remove: anAdvice.! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 9/5/2012 04:46'!
removeWrapper: aWrapper

	onWrappers remove: aWrapper! !

!PhAspect methodsFor: 'removing' stamp: 'mcamp 9/4/2012 01:26'!
removeWrappers

	onWrappers removeAll.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 9/5/2012 04:46'!
uninstall
	PhAspectWeaver uninstallAspect: self.
	self installed: false.
	self removeWrappers.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'mcamp 10/5/2012 01:01'!
uninstallClassModifiers

	self classModifierCollection do:[:aCM|
		aCM uninstall.
	]! !

Object subclass: #PhAspectWeaver
	instanceVariableNames: ''
	classVariableNames: 'ClassModifierDict ClassModifiers CounterAspect InstalledAspect InstalledAspects InstalledCasperSelectors InstalledWrappers Installing'
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:34'!
activateSystemNotification

	SystemAnnouncer uniqueInstance
		on: ClassAdded
		send: #onClassAdded:
		to: self.
		
	SystemAnnouncer uniqueInstance
		on: ClassModifiedClassDefinition
		send: #onClassModified:
		to: self.
	
	SystemAnnouncer uniqueInstance
		on: ClassRemoved
		send: #onClassRemoved:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: ClassRenamed
		send: #onClassRenamed:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: MethodAdded
		send: #onMethodAdded:
		to: self.	
	
	SystemAnnouncer uniqueInstance
		on: MethodModified
		send: #onMethodModified:
		to: self.	

	SystemAnnouncer uniqueInstance
		on: MethodRecategorized 
		send: #onMethodRecategorized:
		to: self.
		
	SystemAnnouncer uniqueInstance
		on: MethodRemoved
		send: #onMethodRemoved:
		to: self.! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/15/2012 22:47'!
addAspect: anAspect
	
	self installedAspects add: anAspect.
	! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/19/2012 01:38'!
addWrapper: aWrapper

	self installedWrappers at: (Array with: aWrapper wrappedClass with: aWrapper selector) ifAbsentPut: aWrapper.! !

!PhAspectWeaver class methodsFor: 'to remove' stamp: 'mcamp 1/3/2013 03:22'!
checkAspectToRemoveMethod: aMethod inClass: aClass

	|sourceBuilder wrappers cCategory|
	
	wrappers := PhAspectWeaver getInstalledWrapperOf: aClass selector: aMethod selector.
	sourceBuilder:= PhSourceBuilder new.
	sourceBuilder 
		source: aMethod sourceCode asText;
		methodDefinition: wrappers.
	
	
	
	"si tiene wrappers, elimino el metodo que correspode, sino, veo si es un metodo casper, si es asi, elimino el metodo original"
	(wrappers isNil not and: [wrappers hasAspects ]) 
		ifTrue: [
			|selectorCasper|
			selectorCasper := wrappers casperSelector.
			aClass removeSelector: selectorCasper
		]
		ifFalse:[ 
			"la manera de ver si es un metodo casper debe ser por el nombre y si el metodo original tiene wrappers!!"
			self flag:#fix.
			aMethod category asString = PhSourceBuilder casperCategory
			 ifTrue:[
				sourceBuilder changeBackSource: aMethod sourceCode asText.
				
				aClass removeSelector: (sourceBuilder selectorOfSource: sourceBuilder source asText class: aClass).
			]	
		].
	
	self flag:#refactorizar.
	self cleanCasperCategory: PhSourceBuilder casperCategory of: aClass.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/8/2012 20:52'!
classModifierDict

	^ ClassModifierDict ifNil: [ClassModifierDict := PhClassModifierDictionary new].! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/18/2012 03:41'!
cleanAndRemoveWrappersOfAspect: anAspect

	
	anAspect onWrappers do:[:wr| 
		wr removeAspect: anAspect.
		wr removeAdvices: anAspect adviceCollection.
		wr hasAspects ifFalse: [self removeWrapper: wr].
	]! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/18/2012 01:55'!
cleanAspectsOfWrappers

	self installedWrappers do: [:wr|
		wr cleanAspects.
	]

	! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/5/2012 01:21'!
cleanCasperCategory: aCategory of: aClass

	(aClass organization listAtCategoryNamed: aCategory)
		isEmptyOrNil ifTrue: [aClass removeCategory: aCategory] ! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 11/5/2012 23:02'!
cleanCasperCategoryOfClass: aClass
	|cCategory|
	
	cCategory := PhSourceBuilder casperCategory.
	(aClass organization listAtCategoryNamed: cCategory)
		isEmptyOrNil ifTrue: [aClass removeCategory: cCategory] ! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/11/2012 02:26'!
counterAspect

	^ CounterAspect ifNil: [CounterAspect := 1000].! !

!PhAspectWeaver class methodsFor: 'adding' stamp: 'mcamp 10/11/2012 12:08'!
counterAspectAdd: aNumber

	CounterAspect := CounterAspect + aNumber .! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/16/2012 04:39'!
generateClassModifiers

	self installedAspects do:[:asp| 
		asp classModifierCollection do: [:cm|
			|classes|
			
			classes := cm pointcut getMatchedClasses.
			self classModifierDict atAll: classes put: cm.	
		]
	].
! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 11/7/2012 02:41'!
generateWrappers

	|dictSub dictNormal|
	
	self installedAspects do:[:asp| self updateWrappersWithAspect: asp].
! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/11/2012 12:08'!
getCounterAndAddOne

	|counter|
	counter := self counterAspect.
	self counterAspectAdd: 1.
	^counter.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 01:37'!
getInstalledWrapperOf: aClass selector: aSelector
	"get the wrapper of aSelector of aClass, return the wrapper (only one) or nil"

	^self installedWrappers at: (Array with: aClass with: aSelector) ifAbsent:[nil].! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 11/6/2012 22:47'!
getWrapperOfReceiver: aReceiver selector: aSelector

	^self installedWrappers 
		at: (Array with: aReceiver with: aSelector)
		ifAbsentPut: [
			|wr|
			wr := PhMethodWrapper 
					wrappedClass: aReceiver
					selector: aSelector.
			self addWrapper: wr.
			wr
		]
	! !

!PhAspectWeaver class methodsFor: 'testing' stamp: 'mcamp 10/19/2012 02:06'!
hasCasperSelector: aSelector ofClass: aClass

	self installedCasperSelectors 
		at: (Array with: aClass with: aSelector )
		ifPresent: [:arr| ^true]
		ifAbsent: [^false].

	^false.! !

!PhAspectWeaver class methodsFor: 'initialize-release' stamp: 'mcamp 10/19/2012 05:03'!
initialize
	super initialize.
	self activateSystemNotification.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/19/2012 00:41'!
installAspect: anAspect

	self uninstallAndCleanWrappers.
	self addAspect: anAspect.
	
	self installAspects. 
	

	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:48'!
installAspects

	self flag: #installing.
	self installing: true.
	
	self generateClassModifiers.
	self installClassModifiers.
	self generateWrappers.
	self installWrappers.
	
	self installing: false.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:49'!
installClassModifiers
	
	self flag: #installing.
	self installing: true.
	
	self classModifierDict keysAndValuesDo: [:cls :cms|
		cms do:[:cm| cm installOn: cls]	
	].

	self installing: false.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 11/7/2012 02:45'!
installWrappers

	|subWrappers normalWrappers|
	self flag: #installing.
	self installing: true.
	
	subWrappers := self installedWrappers select: [:v| v onSuperClass].
	normalWrappers := self installedWrappers select: [:v| v onSuperClass not].
	(Array with: subWrappers with: normalWrappers)
		do:[:awr|
			awr do:[:wr|
				wr install.	
				self installedCasperSelectors 
					at: (Array with: wr wrappedClass with: wr selector)
					put: wr casperSelector.
			].
		].

	self installing: false.! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 9/13/2012 03:39'!
installedAspects

	^ InstalledAspects ifNil: [InstalledAspects := Set new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 01:31'!
installedCasperSelectors

	^ InstalledCasperSelectors ifNil: [InstalledCasperSelectors := Dictionary new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/19/2012 02:21'!
installedWrappers

	^ InstalledWrappers ifNil: [InstalledWrappers := Dictionary new.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/25/2012 00:42'!
installing

	^ Installing ifNil: [Installing := false.]! !

!PhAspectWeaver class methodsFor: 'accessors' stamp: 'mcamp 10/25/2012 00:43'!
installing: aBoolean

	Installing := aBoolean.! !

!PhAspectWeaver class methodsFor: 'testing' stamp: 'mcamp 10/19/2012 02:03'!
isCasperSelector: aCasperSelector ofClass: aClass

	self installedCasperSelectors keysAndValuesDo: [:anArray :aCspSel|
		((anArray at: 1) == aClass and: [aCspSel == aCasperSelector])
			ifTrue: [^true].
	].

	^false.! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 00:45'!
onClassAdded: aClassAdded

	self installing ifFalse:[
		self reinstallAspects
	]! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassModified: aClassModifiedClassDefinition

	self installing ifFalse:[
		self reinstallAspects
	]! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassRemoved: aClassRemoved

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:35'!
onClassRenamed: aClassRenamed

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodAdded: aMethodAdded

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodModified: aMethodModified

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:36'!
onMethodRecategorized: aMethodRecategorized

	self installing ifFalse:[
		self reinstallAspects
	]
	! !

!PhAspectWeaver class methodsFor: 'notification' stamp: 'mcamp 10/25/2012 01:37'!
onMethodRemoved: aMethodRemoved

	self flag:#installing.
	self installing ifFalse:[
		
	self installing:true.
	
	(self isCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass)
		ifTrue: [self removeSelectorOfCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass].
	(self hasCasperSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass)
		ifTrue: [self removeCasperSelectorOfSelector: aMethodRemoved selector ofClass: aMethodRemoved methodClass].
		
	self reinstallAspects.
	
	self installing: false.
	
	].
	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 11/5/2012 19:56'!
reinstallAspects

	self flag: #installing.
	self installing: true.
	
	self uninstallAndCleanWrappers.
	self uninstallClassModifiers.
	
	self installAspects.
	
	self installing: false.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/18/2012 03:29'!
removeAllWrappers

	self installedWrappers removeAll. ! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/18/2012 03:27'!
removeAspect: anAspect

	self installedAspects remove: anAspect.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:37'!
removeCasperSelectorOf: aSelector ofClass: aClass.

	self installedCasperSelectors
	removeKey: (Array with: aClass with: aSelector)
	ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 11/5/2012 23:02'!
removeCasperSelectorOfSelector: aSelector ofClass: aClass

	|casperSelector cCategory|
	
	casperSelector := self installedCasperSelectors at: (Array with: aClass with: aSelector).
	self removeSelector: casperSelector ofClass: aClass.
	self removeWrapperOfSelector: aSelector ofClass: aClass.
	self removeCasperSelectorOf: aSelector ofClass: aClass.
	
	self cleanCasperCategoryOfClass: aClass.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:11'!
removeSelector: aSelector ofClass: aClass

	aClass removeSelector: aSelector.! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 11/5/2012 23:02'!
removeSelectorOfCasperSelector: aCasperSelector ofClass: aClass

	self installedCasperSelectors keysAndValuesDo: [:anArray :aCspSel|
		((anArray at: 1) == aClass and:[aCspSel == aCasperSelector ])
			ifTrue:[
				self removeSelector: (anArray at: 2) ofClass: aClass.	
				self removeWrapperOfSelector: (anArray at: 2) ofClass: aClass.
				self removeCasperSelectorOf: (anArray at: 2) ofClass: aClass.
				
				self cleanCasperCategoryOfClass: aClass
			]	
	]! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 01:46'!
removeWrapper: aWrapper

	self installedWrappers 
	removeKey: (Array with: aWrapper wrappedClass with: aWrapper selector)
	ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'removing' stamp: 'mcamp 10/19/2012 02:30'!
removeWrapperOfSelector: aSelector ofClass: aClass.

	self installedWrappers 
		removeKey: (Array with: aClass with: aSelector)
		ifAbsent:[].! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 9/13/2012 03:40'!
uninstallAll

	self installedAspects do:[:aspect| aspect uninstall].! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:48'!
uninstallAndCleanWrappers

	self flag:#installing.
	self installing: true.
	
	self uninstallAspectsWithoutRemove.
	self cleanAspectsOfWrappers.
	
	self installing: false.
	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 11/5/2012 19:58'!
uninstallAspect: anAspect

	self flag: #installing.
	self installing: true.
	
	self uninstallAspectsWithoutRemove.
	self cleanAndRemoveWrappersOfAspect: anAspect.
	self removeAspect: anAspect.
	
	self cleanAspectsOfWrappers.
	self installAspects.
	
	self installing: false.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/16/2012 02:35'!
uninstallAspectsWithoutRemove

	self uninstallWrappers.
	self uninstallClassModifiers.! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:47'!
uninstallClassModifiers

	self flag:#installing.
	self installing: true.

	self classModifierDict keysAndValuesDo: [:cls :cms|
		cms do:[:cm| cm uninstallOn: cls].
	].
	self classModifierDict removeAll.
	
	self installing: false.

	! !

!PhAspectWeaver class methodsFor: 'install-uninstall' stamp: 'mcamp 10/25/2012 00:40'!
uninstallWrappers

	self installedWrappers do:[:wr| 
		wr uninstall.
		self installedCasperSelectors
			removeKey: (Array with: wr wrappedClass with: wr selector)
	].! !

!PhAspectWeaver class methodsFor: 'private' stamp: 'mcamp 10/15/2012 22:49'!
updateWrappersWithAspect: anAspect

	anAspect adviceCollection do:[ :adv|
		adv pointcut getPointcuts do:[:pc| |mw|
			mw := self getWrapperOfReceiver: (pc at:1) selector: (pc at:2).
			mw addAdvice: adv.
			
			mw addAspect: anAspect.
			self addWrapper: mw.
			anAspect addWrapper: mw.
		]
	].! !

Object subclass: #PhClassModifier
	instanceVariableNames: 'newInstanceVars newMethods newClassVars newClassMethods pointcut onClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/4/2012 03:58'!
addMethod: aSymbol
	newMethods add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:28'!
addNewClassMethod: aSymbol
	newClassMethods add: aSymbol! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewClassVar: aSymbol
	newClassVars add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewInstanceMethod: aSymbol
	newMethods add: aSymbol.! !

!PhClassModifier methodsFor: 'adding' stamp: 'mcamp 10/12/2012 00:29'!
addNewInstanceVar: aSymbol
	newInstanceVars add: aSymbol.! !

!PhClassModifier methodsFor: 'private' stamp: 'mcamp 10/16/2012 04:27'!
checkIfCanInstallOn: aClass


	newInstanceVars
		do: [ :varName | 
			(aClass theNonMetaClass hasInstVarNamed: varName)
				ifTrue: [ self error: 'instance variable already defined!!' ] ].
	newClassVars
		do: [ :varName | 
			(aClass theNonMetaClass hasClassVarNamed: varName)
				ifTrue: [ self error: 'class variable already defined!!' ] ].
	newMethods
		do: [ :selector | 
			(aClass theNonMetaClass allSelectors includes: selector)
				ifTrue: [ self error: 'instance method already defined!!' ] ].
	newClassMethods
		do: [ :selector | 
			(aClass theMetaClass allSelectors includes: selector)
				ifTrue: [ self error: 'class method already defined!!' ] ].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:28'!
compileClass: class WithMethodsProvidedBy: aClass.

	self compileInstVarsOn: class.
	self compileClassVarsOn: class.
	self compileInstMethodsOn: class providedBy: aClass.
	self compileClassMethodsOn: class providedBy: aClass.
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileClassMethodsOn: class providedBy: aClass

	|sources|
	
	sources := newClassMethods collect: [:m| (aClass methodDict at: m) sourceCode].
	 
	sources do:[:source|
		class theMetaClass compile: source classified: PhSourceBuilder casperClassModifiedCategory
		
	].
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileClassVarsOn: aClass

	newClassVars do:[:clsVar| aClass addClassVarNamed: clsVar].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/5/2012 01:16'!
compileClasses: classes WithMethodsProvidedBy: aClass.

	self compileInstVarsOn: classes.
	self compileClassVarsOn: classes.
	self compileInstMethodsOn: classes providedBy: aClass.
	self compileClassMethodsOn: classes providedBy: aClass.
	! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileInstMethodsOn: class providedBy: aClass

	|sources|
	
	sources := newMethods collect: [:m| (aClass methodDict at: m) sourceCode].

	sources do:[:source|
		class compile: source classified: PhSourceBuilder casperClassModifiedCategory
	
	].! !

!PhClassModifier methodsFor: 'compiling' stamp: 'mcamp 10/16/2012 04:29'!
compileInstVarsOn: class

	|instVarString|
	instVarString := ''.
	newInstanceVars  do:[:aInstVar| instVarString := instVarString,' ',aInstVar ].
	class addInstVarNamed: instVarString.
	! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'mcamp 10/3/2012 03:33'!
initialize

	super initialize.
	newClassMethods := OrderedCollection new.
	newClassVars := OrderedCollection new.
	newInstanceVars := OrderedCollection new.
	newMethods := OrderedCollection new.! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'mcamp 10/16/2012 04:26'!
installOn: aClass

	self checkIfCanInstallOn: aClass.
	self compileClasses: aClass WithMethodsProvidedBy: self class.
	! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassMethods
	^ newClassMethods! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassMethods: anObject
	newClassMethods := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassVars
	^ newClassVars! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newClassVars: anObject
	newClassVars := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newInstanceVars
	^ newInstanceVars! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newInstanceVars: anObject
	newInstanceVars := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newMethods
	^ newMethods! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 03:57'!
newMethods: anObject
	newMethods := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 13:03'!
onClasses
	^ onClasses! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/4/2012 13:03'!
onClasses: anObject
	onClasses := anObject! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/3/2012 03:35'!
pointcut
	^ pointcut! !

!PhClassModifier methodsFor: 'accessing' stamp: 'mcamp 10/3/2012 03:35'!
pointcut: anObject
	pointcut := anObject! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/18/2012 02:59'!
removeChangeOfClass: class.

	self removeClassMethodsOf: class.
	self removeInstMethodsOf: class.
	self removeClassVarOf: class.
	self removeInstVarOf: class.
		
	PhAspectWeaver cleanCasperCategory: PhSourceBuilder casperClassModifiedCategory of: class.
	! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/12/2012 00:54'!
removeClassMethodsOf: aClass

	newClassMethods do:[:selector|
		aClass theMetaClass methodDict at: selector ifPresent:[:method|
			PhAspectWeaver checkAspectToRemoveMethod: method  inClass: aClass theMetaClass.
			aClass theMetaClass removeSelector: selector.
		].
	]
	
! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:36'!
removeClassVarOf: aClass

	newClassVars do:[:var|
		(aClass classPool includesKey: var ) ifTrue: [
			aClass removeClassVarNamed: var.
		].
	].! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/9/2012 01:27'!
removeInstMethodsOf: aClass

	newMethods do:[:selector| 
		aClass methodDict at: selector ifPresent: [:method|
			PhAspectWeaver checkAspectToRemoveMethod: method  inClass: aClass.
			aClass removeSelector: selector.
		].
	]! !

!PhClassModifier methodsFor: 'removing' stamp: 'mcamp 10/8/2012 21:37'!
removeInstVarOf: aClass

	newInstanceVars do:[:var| 
		(aClass instVarNames includes: var) ifTrue: [
			aClass removeInstVarNamed: var
		].
	]! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'mcamp 10/18/2012 03:46'!
uninstallOn: aClass

	self removeChangeOfClass: aClass.
	
	
	
! !

Object subclass: #PhContext
	instanceVariableNames: 'arguments dynamicContext receiver selector sender nextContext proceedBlock isOriginal thisAdvice originalArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
arguments
	^ arguments! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:04'!
arguments: anArray
	arguments := anArray! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
dynamicContext
	^ dynamicContext! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
dynamicContext: anObject
	dynamicContext := anObject! !

!PhContext methodsFor: 'initialize-release' stamp: 'mcamp 9/24/2012 01:09'!
initialize

	super initialize.
	isOriginal := false.! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:08'!
isOriginal
	^ isOriginal! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/18/2012 03:05'!
isOriginal: aBoolean
	isOriginal := aBoolean! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/25/2012 23:37'!
newArguments: anArray
	"set this context and all of the context next to this"
	
	self arguments isNil not ifTrue:[ self arguments: anArray].
	self isOriginal 
		ifTrue: [self originalArgs: anArray]
		ifFalse: [self nextContext newArguments: anArray].! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 9/24/2012 01:02'!
nextContext
	^ nextContext! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/18/2012 03:07'!
nextContext: aContext
	nextContext := aContext! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/25/2012 23:37'!
originalArgs
	^ originalArgs! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/25/2012 23:37'!
originalArgs: anObject
	originalArgs := anObject! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/25/2012 23:44'!
proceed
	^ isOriginal ifTrue:[ proceedBlock value: originalArgs] ifFalse: [proceedBlock value: nextContext].! !

!PhContext methodsFor: 'proceed' stamp: 'mcamp 10/25/2012 23:59'!
proceed: anArray

	self newArguments: anArray.
	^self proceed.
	! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/25/2012 23:03'!
proceedBlock
	^ proceedBlock! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/25/2012 23:03'!
proceedBlock: anObject
	proceedBlock := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
receiver
	^ receiver! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
receiver: anObject
	receiver := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
selector
	^ selector! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:07'!
selector: aSelector
	selector := aSelector! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
sender
	^ sender! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 04:09'!
sender: anObject
	sender := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 13:20'!
thisAdvice
	^ thisAdvice! !

!PhContext methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
thisAdvice: anAdvice
	thisAdvice := anAdvice! !

Object subclass: #PhMethodWrapper
	instanceVariableNames: 'aspects adviceGroup casperSelector casperCounter wrappedClass selector onSuperClass superclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhMethodWrapper class methodsFor: 'accessing' stamp: 'mcamp 1/6/2013 19:59'!
specialCharacters

	^#($+ $- $= $< $> $| $& $% $? $ $!! $ $* $\ $/)! !

!PhMethodWrapper class methodsFor: 'instance creation' stamp: 'mcamp 11/6/2012 22:55'!
wrappedClass: aReceiver selector: aSelector

	^self new
		wrappedClass: aReceiver;
		selector: aSelector;
		checkSuperclass.! !

!PhMethodWrapper methodsFor: 'adding' stamp: 'mcamp 9/28/2012 00:58'!
addAdvice: anAdvice
	
	adviceGroup addAdvice: anAdvice.
	! !

!PhMethodWrapper methodsFor: 'adding' stamp: 'mcamp 9/4/2012 01:21'!
addAspect: anAspect

	aspects add: anAspect.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 00:55'!
adviceGroup
	^ adviceGroup! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:09'!
adviceGroup: anAdvGroup
	adviceGroup := anAdvGroup! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 02:18'!
advices
	^adviceGroup.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:01'!
afterAdvices
	^adviceGroup afterAdvices.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:01'!
aroundAdvices
	^ adviceGroup aroundAdvices ! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/4/2012 01:19'!
aspects
	^ aspects! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:09'!
aspects: aSet
	aspects := aSet! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:02'!
beforeAdvices
	^ adviceGroup beforeAdvices! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/12/2012 02:36'!
casperCounter
	^ casperCounter! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:10'!
casperCounter: anString
	casperCounter := anString! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/11/2012 12:15'!
casperSelector
	^ casperSelector! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:10'!
casperSelector: aSelector
	casperSelector := aSelector! !

!PhMethodWrapper methodsFor: 'private' stamp: 'mcamp 11/7/2012 01:56'!
checkSuperclass

	onSuperClass := false.
	(wrappedClass methodDict includesKey: selector)
		ifFalse:[
			|sclass|
			onSuperClass := true.
			sclass := wrappedClass superclass.
			[sclass methodDict includesKey: selector] whileFalse:[
				sclass := sclass superclass.
			].
			superclass := sclass.
		].
	! !

!PhMethodWrapper methodsFor: 'private' stamp: 'mcamp 10/18/2012 03:13'!
cleanAspects

	self flag:#refactorizar.
	"use remove all"
	aspects := Set new.
	adviceGroup := PhAdviceGroup new.
	
	! !

!PhMethodWrapper methodsFor: 'common' stamp: 'mcamp 10/11/2012 15:53'!
commonContext

	|contexts|
	
	contexts := Set new.
	adviceGroup allAdvices do:[:adv| 
		(adv pointcut context) ifNotNil: [contexts addAll: (adv pointcut context) ].
	].
	^contexts.! !

!PhMethodWrapper methodsFor: 'testing' stamp: 'mcamp 9/4/2012 01:32'!
hasAspects

	^ aspects isEmptyOrNil not.! !

!PhMethodWrapper methodsFor: 'initialize-release' stamp: 'mcamp 9/28/2012 00:45'!
initialize

	super initialize.
	aspects := Set new.
	adviceGroup := PhAdviceGroup new.! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'mcamp 1/7/2013 00:32'!
install

	|sourceBuilder newSource category classSource|
	
	"take out source:, build from sourceBuilder"
	self onSuperClass 
		ifTrue:[classSource := superclass]
		ifFalse:[classSource := wrappedClass].
	self flag: #takeOutSource.
	sourceBuilder := PhAbstractSourceBuilder createFromMethodDefinition: self source: (classSource methodDict at:  selector) sourceCode asText.
	category := (classSource methodDict at: selector) category.
	newSource := sourceBuilder buildNewSource.
	
	
	wrappedClass compile: newSource classified: category.! !

!PhMethodWrapper methodsFor: 'testing' stamp: 'mcamp 1/6/2013 20:03'!
isSpecialSelector

	|s|
	
	s := selector first.
	^self class specialCharacters includes: s.
	! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 22:46'!
onSuperClass
	^ onSuperClass! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 22:46'!
onSuperClass: aBoolean
	onSuperClass := aBoolean! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/28/2012 01:02'!
removeAdvices: advices

	adviceGroup removeAdvices: advices.
	
	
	! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 9/13/2012 04:03'!
removeAspect: anAspect

	aspects remove: anAspect ifAbsent:[].
	! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
selector
	^ selector! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:12'!
selector: aSelector
	selector := aSelector! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 22:46'!
superclass
	^ superclass! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 22:46'!
superclass: anObject
	superclass := anObject! !

!PhMethodWrapper methodsFor: 'install-uninstall' stamp: 'mcamp 1/6/2013 21:54'!
uninstall

	|sourceBuilder originalSource cCategory originalCategory |
	
	self onSuperClass 
		ifTrue:[
			wrappedClass removeSelector: casperSelector.
			wrappedClass removeSelector: selector.
		]
		ifFalse:[
			sourceBuilder := PhAbstractSourceBuilder createFromMethodDefinition: self source: (wrappedClass methodDict at:  selector) sourceCode asText.
		
	
			originalSource := sourceBuilder originalSourceCodeOfCasperSelector: casperSelector.
	
			wrappedClass removeSelector: casperSelector.
			originalCategory := (wrappedClass methodDict at: selector) category.
			wrappedClass compile: originalSource classified: originalCategory.
		].
	
	"clean casper category"
	wrappedClass organization removeEmptyCategories.! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:08'!
wrappedClass
	^ wrappedClass! !

!PhMethodWrapper methodsFor: 'accessing' stamp: 'mcamp 10/18/2012 03:12'!
wrappedClass: aClass
	wrappedClass := aClass! !

Object subclass: #PhPointcutAbstract
	instanceVariableNames: 'ifBlock context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

PhPointcutAbstract subclass: #PhPointcut
	instanceVariableNames: 'receivers selectors localSelectors withinClasses pragmas package noPackages withoutPrimitives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

PhPointcut subclass: #PhCFlowPointcut
	instanceVariableNames: 'inCflowOf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhCFlowPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/6/2012 04:42'!
pointcut: aPC inCflowOf: anotherPC

	|pc|
		
	pc := self new.
	pc
		selectors: aPC selectors;
		receivers: aPC receivers;
		context: aPC context;
		if: aPC ifBlock;
		package: aPC package;
		withinClasses: aPC withinClasses;
		inCflowOf: anotherPC;
		if: aPC ifBlock.
		
	^pc.! !

!PhCFlowPointcut methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 00:46'!
inCflowOf
	^ inCflowOf! !

!PhCFlowPointcut methodsFor: 'accessing' stamp: 'mcamp 11/6/2012 00:46'!
inCflowOf: anObject
	inCflowOf := anObject! !

!PhCFlowPointcut methodsFor: 'testing' stamp: 'mcamp 11/6/2012 05:21'!
isActivateOnCflowOf: smCtx

	|sender pointcuts|
	
	pointcuts := inCflowOf getPointcuts.
	sender := smCtx sender.
	[sender isNil] whileFalse:[
		|arr|
		arr := Array with: sender receiver class with: sender method selector.
		(pointcuts includes: arr) ifTrue: [^true].
		sender := sender sender.
	].
	
	^false.! !

!PhCFlowPointcut methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:26'!
isCflowPointcut

	^true.! !

!PhCFlowPointcut methodsFor: 'testing' stamp: 'mcamp 11/6/2012 02:49'!
isConditional

	^ true.! !

!PhPointcut class methodsFor: 'utils' stamp: 'mcamp 1/7/2013 01:06'!
hasPrimitives: pragmas

	pragmas do:[:prg|
		(prg keyword = #primitive:) ifTrue:[^true].		
	].

	^false.! !

!PhPointcut class methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:44'!
packagesRestricted

	^#('Kernel' 'Collections')! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/5/2012 23:13'!
receivers: rec

	^ self new receivers: rec.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 1/7/2013 00:36'!
receivers: rec localSelectors: sel pragmas: prg

	^self new 
		localSelectors: sel;
		receivers: rec;
		pragmas: prg.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:32'!
receivers: rec packages: res

	^ self new receivers: rec; restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:32'!
receivers: rec selectors: sel 

	^self new 
		selectors: sel;
		receivers: rec.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:32'!
receivers: rec selectors: sel  context: array 

	^self new
		selectors: sel;
		receivers: rec;
		context: array.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:44'!
receivers: rec selectors: sel context: array if: block

	^ self new
		selectors: sel;
		receivers: rec;
		context: array;
		if: block.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:45'!
receivers: rec selectors: sel context: array if: block packages: res

	^ self new
		selectors: sel;
		receivers: rec;
		context: array;
		if: block;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:45'!
receivers: rec selectors: sel context: array packages: res

	^self new
		selectors: sel;
		receivers: rec;
		context: array;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:45'!
receivers: rec selectors: sel  packages: res

	^self new 
		selectors: sel;
		receivers: rec;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:46'!
receivers: rec selectors: sel pragmas: prg

	^self new 
		selectors: sel;
		receivers: rec;
		pragmas: prg.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:47'!
receivers: rec selectors: sel  pragmas: prg context: array 

	^self new
		selectors: sel;
		receivers: rec;
		pragmas: prg;
		context: array.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:47'!
receivers: rec selectors: sel pragmas: prg context: array if: block

	^ self new
		selectors: sel;
		receivers: rec;
		pragmas: prg;
		context: array;
		if: block.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:47'!
receivers: rec selectors: sel pragmas: prg context: array if: block packages: res

	^ self new
		selectors: sel;
		receivers: rec;
		pragmas: prg;
		context: array;
		if: block;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:47'!
receivers: rec selectors: sel pragmas: prg context: array packages: res

	^self new
		selectors: sel;
		receivers: rec;
		pragmas: prg;
		context: array;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'instance creation' stamp: 'mcamp 11/27/2012 22:47'!
receivers: rec selectors: sel  pragmas: prg packages: res

	^self new 
		selectors: sel;
		receivers: rec;
		pragmas: prg;
		restrictToPackages: res.! !

!PhPointcut class methodsFor: 'utils' stamp: 'mcamp 1/6/2013 21:39'!
to: aCollection addAllIfNotPresent: collection


	collection do:[:elem| self to: aCollection addIfNotPresent: elem].! !

!PhPointcut class methodsFor: 'utils' stamp: 'mcamp 1/6/2013 21:39'!
to: aCollection addIfNotPresent: elem

	aCollection do:[:k|
		((elem selector) = (k class)) ifTrue:[^self].
	].
	aCollection add: elem.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/6/2012 01:34'!
context: anObject
	context := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:18'!
getMatchedClasses
	|classes rm|
	
	classes := Set new.
	receivers isString 
		ifTrue:[
			rm := PhReceiverMatcher receivers: receivers. 
			rm withoutPackages: self noPackages.
			rm withinClasses: self getRestrictionClasses. 
			classes addAll: rm getAllReceiversThatMatch.
		]
		ifFalse:[
			receivers do:[:r|
				rm := PhReceiverMatcher receivers: r.
				rm withoutPackages: self noPackages.
				rm withinClasses: self getRestrictionClasses. 
				classes addAll: rm getAllReceiversThatMatch.
			].
		].
	^classes.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:17'!
getPointcuts
	|classes methods rm pm|
	
	methods := OrderedCollection new.
	
	"match pragma"
	pragmas isEmptyOrNil ifFalse: [
		pm := PhPragmaMatcher new buildMatch: pragmas. 	
	].

	"que pase esta logica a la clase PhReceiverMatcher"
	self flag: #refactoring.
	classes := self getMatchedClasses.
	
	classes do: [:aClass| 
		|sel|
		
		sel :=((PhSelectorMatcher selectors: selectors) getAllMethodsThatMatchOfClass: aClass).
		PhPointcut to: sel addAllIfNotPresent: ((PhSelectorMatcher selectors: localSelectors) getAllLocalMethodsThatMatchOfClass: aClass).
	
		"match pragma"
		pragmas isEmptyOrNil ifFalse: [
			sel := pm withinClass: aClass;
					withinMethods: sel;
					methodsMatchPragma. 
		].
		self withoutPrimitives ifTrue:[
			sel := sel select:[:aCompMethod| (self class hasPrimitives: aCompMethod pragmas) not ].
		].
		methods addAll: (sel collect: [:aSelector| Array with: aClass with: aSelector selector]).
	].
	^ methods asSet.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:30'!
getRestrictionClasses

	withinClasses isNil 
		ifTrue: [^Smalltalk allClasses]
		ifFalse: [^withinClasses].! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 11/5/2012 21:18'!
if: aBlock
	ifBlock := aBlock! !

!PhPointcut methodsFor: 'initialize-release' stamp: 'mcamp 1/20/2013 19:15'!
initialize

	super initialize.
	self withoutPrimitives: true.
	self noPackages: self class packagesRestricted.! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 03:38'!
localSelectors
	^ localSelectors! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 03:38'!
localSelectors: anObject
	localSelectors := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:14'!
noPackages
	^ noPackages! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:14'!
noPackages: anArray
	noPackages := anArray! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:30'!
package
	^ package! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:32'!
package: anObject
	package := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:50'!
pragmas
	^ pragmas! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:50'!
pragmas: anObject
	pragmas := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
receivers
	^ receivers! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
receivers: aString
	receivers := aString! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 9/23/2012 19:43'!
restrictToPackages: anArray

	|classes|
	
	package := anArray.
	classes := Set new.
	anArray do:[:aPackage|
		(PackageOrganizer default packageNamed: aPackage ifAbsent:[nil])
		ifNotNil:[:packageInfo|
			classes addAll: packageInfo classes.
		]
	].
	withinClasses := classes.! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
selectors
	^ selectors! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/13/2012 22:45'!
selectors: aString
	selectors := aString! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 22:48'!
withinClasses
	^ withinClasses! !

!PhPointcut methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 22:48'!
withinClasses: anObject
	withinClasses := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/7/2013 00:54'!
withoutPrimitives
	^ withoutPrimitives! !

!PhPointcut methodsFor: 'accessing' stamp: 'mcamp 1/7/2013 00:54'!
withoutPrimitives: anObject
	withoutPrimitives := anObject! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'mcamp 11/5/2012 21:54'!
context

	^context! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:38'!
getPointcuts
	
	^self subclassResponsibility.! !

!PhPointcutAbstract methodsFor: 'testing' stamp: 'mcamp 10/22/2012 20:34'!
hasIfBlock
	^ ifBlock isNil not.! !

!PhPointcutAbstract methodsFor: 'accessing' stamp: 'mcamp 10/22/2012 20:02'!
ifBlock
	^ ifBlock! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 11/6/2012 04:41'!
inCflowOf: aPC

	^PhCFlowPointcut pointcut: self inCflowOf: aPC.! !

!PhPointcutAbstract methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:24'!
isActivateOnCflowOf: smCtx
	
	^self subclassResponsibility.! !

!PhPointcutAbstract methodsFor: 'testing' stamp: 'mcamp 11/6/2012 03:25'!
isCflowPointcut

	^false! !

!PhPointcutAbstract methodsFor: 'testing' stamp: 'mcamp 11/6/2012 02:48'!
isConditional

	^ self hasIfBlock.! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 11/5/2012 21:28'!
not
	
	^PhPointcutNot pointcut: self.! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 11/5/2012 21:29'!
pand: aPointcut.
	
	^ PhPointcutAnd leftPointcut: self rightPointcut: aPointcut.! !

!PhPointcutAbstract methodsFor: 'composing' stamp: 'mcamp 11/5/2012 21:29'!
por: aPointcut.
	
	^ PhPointcutOr leftPointcut: self rightPointcut: aPointcut.! !

PhPointcutAbstract subclass: #PhPointcutAnd
	instanceVariableNames: 'leftPointcut rightPointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutAnd class methodsFor: 'instance creation' stamp: 'mcamp 11/5/2012 21:41'!
leftPointcut: aPC rightPointcut: anotherPC

	|pc|
	pc := self new.
	pc leftPointcut: aPC;
		rightPointcut: anotherPC;
		makeIf;
		makeContext.
		
	^ pc.! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:41'!
getPointcuts
	
	 ^leftPointcut getPointcuts intersection: rightPointcut getPointcuts.! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
leftPointcut
	^ leftPointcut! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
leftPointcut: anObject
	leftPointcut := anObject! !

!PhPointcutAnd methodsFor: 'private' stamp: 'mcamp 11/5/2012 22:13'!
makeContext

	leftPointcut context isNil 
		ifTrue: [context := rightPointcut context]
		ifFalse: [
			rightPointcut context isNil 
				ifTrue: [context := leftPointcut context]
				ifFalse: [context := (leftPointcut context asSet addAll: (rightPointcut context)) asArray]
			]! !

!PhPointcutAnd methodsFor: 'private' stamp: 'mcamp 11/5/2012 22:14'!
makeIf

	leftPointcut hasIfBlock
		ifTrue: [ifBlock := rightPointcut ifBlock]
		ifFalse: [
			rightPointcut hasIfBlock
				ifTrue: [ifBlock := [ (leftPointcut ifBlock value) and: rightPointcut ifBlock]]
				ifFalse: [ifBlock := leftPointcut ifBlock]
		]! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
rightPointcut
	^ rightPointcut! !

!PhPointcutAnd methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:46'!
rightPointcut: anObject
	rightPointcut := anObject! !

PhPointcutAbstract subclass: #PhPointcutNot
	instanceVariableNames: 'pointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutNot class methodsFor: 'instance creation' stamp: 'mcamp 11/5/2012 21:41'!
pointcut: aPC

	|pc|
	pc := self new.
	pc pointcut: aPC;
		makeIf;
		makeContext.
		
	^ pc.! !

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/20/2012 03:52'!
getPointcuts
	|originalPointcuts classes newPointcuts|
	
	self flag:#createListOfPoincuts.
	newPointcuts := Set new.
	
	originalPointcuts := pointcut getPointcuts.

	classes :=  (originalPointcuts collect:[:p| p at: 1]).
	
	pointcut getRestrictionClasses
		do: [:aClass| 
			(Array with: aClass with: aClass class) do:[:each|
				(classes includes: each)
					ifTrue:[
						|selectors newSelectors|
						selectors:= originalPointcuts select: [:p| (p at:1) == each] thenCollect:[:p| p at: 2].
						newSelectors := each allSelectors asSet difference: selectors asSet.
						newPointcuts addAll: (newSelectors collect:[:aSelector| Array with: each with: aSelector]).
					]
					ifFalse:[
						newPointcuts addAll: (each allSelectors collect:[:aSelector| Array with: each with: aSelector])	
					]
			]
		].
	^ newPointcuts.! !

!PhPointcutNot methodsFor: 'private' stamp: 'mcamp 11/5/2012 21:58'!
makeContext

	context := pointcut context.! !

!PhPointcutNot methodsFor: 'private' stamp: 'mcamp 11/5/2012 21:30'!
makeIf

	ifBlock := [pointcut ifBlock value not].! !

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:56'!
pointcut
	^ pointcut! !

!PhPointcutNot methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:56'!
pointcut: anObject
	pointcut := anObject! !

PhPointcutAbstract subclass: #PhPointcutOr
	instanceVariableNames: 'leftPointcut rightPointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPointcutOr class methodsFor: 'instance creation' stamp: 'mcamp 11/5/2012 21:41'!
leftPointcut: aPC rightPointcut: anotherPC

	|pc|
	pc := self new.
	pc leftPointcut: aPC;
		rightPointcut: anotherPC;
		makeIf;
		makeContext.
		
	^ pc.! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
getPointcuts
	
	 ^leftPointcut getPointcuts union: rightPointcut getPointcuts.! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
leftPointcut
	^ leftPointcut! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
leftPointcut: anObject
	leftPointcut := anObject! !

!PhPointcutOr methodsFor: 'private' stamp: 'mcamp 11/5/2012 22:12'!
makeContext

	leftPointcut context isNil 
		ifTrue: [context := rightPointcut context]
		ifFalse: [
			rightPointcut context isNil 
				ifTrue: [context := leftPointcut context]
				ifFalse: [context := (leftPointcut context asSet addAll: (rightPointcut context)) asArray]
			]! !

!PhPointcutOr methodsFor: 'private' stamp: 'mcamp 11/5/2012 22:14'!
makeIf

	leftPointcut hasIfBlock
		ifTrue: [ifBlock := rightPointcut ifBlock]
		ifFalse: [
			rightPointcut hasIfBlock
				ifTrue: [ifBlock := [ (leftPointcut ifBlock value) or: rightPointcut ifBlock]]
				ifFalse: [ifBlock := leftPointcut ifBlock]
		]
	! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
rightPointcut
	^ rightPointcut! !

!PhPointcutOr methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 18:54'!
rightPointcut: anObject
	rightPointcut := anObject! !

Object subclass: #PhPragmaMatcher
	instanceVariableNames: 'withinMethods withinClass arrayPragmaWithWildcards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/2/2012 00:04'!
argument: anObject equal: otherObject

	"OrderedCollection and Array no son iguales, no importa pq solo se usa en pragma"
	(anObject class == otherObject class ) ifFalse: [^false].
	(anObject isArray and:[otherObject isArray]) ifTrue:[
		(1 to: anObject size) do:[:index|
			(self argument: (anObject at: index ) equal: (otherObject at: index)) ifFalse:[
				^false.	
			]
		].
		^true.
	].

	^ anObject = otherObject ! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:01'!
arrayPragmaWithWildcards
	^ arrayPragmaWithWildcards! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:01'!
arrayPragmaWithWildcards: anObject
	arrayPragmaWithWildcards := anObject! !

!PhPragmaMatcher methodsFor: 'building' stamp: 'mcamp 9/22/2012 14:45'!
buildMatch: listOrString
	
	listOrString isString 
		ifTrue: [self buildMatchOfString: listOrString]
		ifFalse:[
			listOrString do:[:reg|
				self buildMatchOfString: reg.	
			]	
		]
	

	! !

!PhPragmaMatcher methodsFor: 'building' stamp: 'mcamp 10/1/2012 22:09'!
buildMatchOfString: aRegExp

	|pragma rs index nw txt positionsArgs positionName withoutArgs wildCard|
	
	pragma := PhPragmaWithWildcards new.
	positionsArgs := OrderedCollection new.
	withoutArgs := false.
	wildCard := false.
	positionName := 0.
	rs := aRegExp readStream.
	index := 0.
	"limpio blancos"
	[nw := rs next.
	 nw = Character space] whileTrue:[].

	[(nw == nil) not ] whileTrue:[
		index := index + 1. 
		Transcript show: index.
		(nw== $_) ifTrue: [
			pragma addWildcardName: index. 
			positionName := rs position.
			wildCard := true.
		].
		
		"pragma con argumentos"
		[nw := rs next. ((nw == nil) not and: [(nw == $:) not] )and:[(nw == Character space) not] ] whileTrue:[].
	
		"sin argumentos"
		(nw == nil or:[ nw == Character space] )ifTrue:[withoutArgs := true].
		"con argumentos nw == $:"
		nw == $: ifTrue:[
			"limpio blancos"
			[nw := rs next.
			 nw = Character space] whileTrue:[].
		
			nw == $_ ifTrue:[
				pragma addWildcardArgs: index.
				positionsArgs add: rs position.
			].
		
			"limpio blancos"
			[nw := rs next.
			 nw = Character space] whileTrue:[].
		]
	].
	
	txt := aRegExp asText.
	"replace wildCardName only when is without args"
	(wildCard and: [withoutArgs and:[ index == 1]]) ifTrue:[ txt replaceFrom: positionName  to: positionName - 1 with: 'p'.].
	
	"replace wildCardsArgs to create pragma"
	positionsArgs reverseDo:[:i|
		txt replaceFrom: i + 1 to: i with: ''''.
		txt replaceFrom: i to: i - 1 with: ''''.
	].

	"create pragma"
	pragma pragma:(self pragmaFromText: txt).
	arrayPragmaWithWildcards add: pragma.
	! !

!PhPragmaMatcher methodsFor: 'initialize-release' stamp: 'mcamp 10/1/2012 20:01'!
initialize

	super initialize.
	arrayPragmaWithWildcards  := OrderedCollection new.! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 10/1/2012 22:44'!
matchPragma: p

	arrayPragmaWithWildcards do:[:pwd|
		(self pragma: p matchWithWildcard: pwd ) ifTrue:[^true].
	].
	^false.! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 9/22/2012 15:47'!
methodsMatchPragma

	|methodsMatch|
	
	^self restrictionMethods select:[ :m|
		|pragmas|
		pragmas := m pragmas select: [:p|	self matchPragma: p].
		pragmas isEmptyOrNil not.
	]
	! !

!PhPragmaMatcher methodsFor: 'matching' stamp: 'mcamp 10/1/2012 23:29'!
pragma: aPragma matchWithWildcard: aPragmaWithWildcards

	|keywords arguments keyToMatch argToMatch wildcardNames wildcardArgs |
	
	keywords  := aPragma key subStrings: ':'.
	arguments := aPragma arguments.
	keyToMatch := aPragmaWithWildcards pragma key subStrings: ':'.
	argToMatch := aPragmaWithWildcards pragma arguments.
	wildcardNames := aPragmaWithWildcards wildcardNames.
	wildcardArgs := aPragmaWithWildcards wildcardArgs.
		
	"same size args and names"
	(keywords size == keyToMatch size and: [arguments size == argToMatch size]) ifFalse: [^false].
	
	"match name"
	(keywords == keyToMatch) ifFalse:[
		(1 to: keywords size) do:[:index|
			(wildcardNames includes: index) ifFalse:[
				((keywords at: index) = (keyToMatch at: index) ) ifFalse: [^false]
			]
		].
	].
	"match arguments"
	(arguments == argToMatch ) ifFalse:[
		(1 to: arguments size) do:[:index|
			(wildcardArgs includes: index) ifFalse:[
				( self argument:(arguments at: index) equal: (argToMatch at: index) ) ifFalse: [^false]
			]
		].
	].
	 ^true.! !

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/1/2012 21:10'!
pragmaFromText: aText

	|text|
	text := aText copy.
	text append:'>'.
	text prepend:'<'.
	text prepend: 'fake '.
	
	^(Parser new parse: text readStream class: PhPragmaMatcher) properties pragmas at: 1.! !

!PhPragmaMatcher methodsFor: 'private' stamp: 'mcamp 10/1/2012 19:27'!
pragmasFromString: aString

	^(Parser new parse: aString readStream class: PhPragmaMatcher) properties pragmas.! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/22/2012 15:40'!
restrictionMethods

	withinMethods isEmptyOrNil 
		ifTrue:[^ withinClass allMethods]
		ifFalse:[^withinMethods].! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:34'!
withinClass
	^ withinClass! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 13:34'!
withinClass: anObject
	withinClass := anObject! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 12:50'!
withinMethods
	^ withinMethods! !

!PhPragmaMatcher methodsFor: 'accessing' stamp: 'mcamp 9/21/2012 12:50'!
withinMethods: anObject
	withinMethods := anObject! !

Object subclass: #PhPragmaWithWildcards
	instanceVariableNames: 'pragma wildcardNames wildcardArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhPragmaWithWildcards methodsFor: 'adding' stamp: 'mcamp 10/1/2012 20:07'!
addWildcardArgs: aNumber

	wildcardArgs add: aNumber.! !

!PhPragmaWithWildcards methodsFor: 'adding' stamp: 'mcamp 10/1/2012 20:07'!
addWildcardName: aNumber

	wildcardNames add: aNumber.! !

!PhPragmaWithWildcards methodsFor: 'initialize-release' stamp: 'mcamp 10/1/2012 20:14'!
initialize

	wildcardArgs := OrderedCollection new.
	wildcardNames := OrderedCollection new.! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
pragma
	^ pragma! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
pragma: anObject
	pragma := anObject! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardArgs
	^ wildcardArgs! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardArgs: anObject
	wildcardArgs := anObject! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardNames
	^ wildcardNames! !

!PhPragmaWithWildcards methodsFor: 'accessing' stamp: 'mcamp 10/1/2012 20:00'!
wildcardNames: anObject
	wildcardNames := anObject! !

Object subclass: #PhReceiverMatcher
	instanceVariableNames: 'receiverNames receiverNamesClean withinClasses withoutPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhReceiverMatcher class methodsFor: 'utilities' stamp: 'MiguelCampusano 8/16/2012 02:20'!
class: aClass inheritsFromClassIn: anOrederedCollection
	
 	anOrederedCollection do:[:class| (aClass inheritsFrom: class) ifTrue:[^true]].	
	^false.! !

!PhReceiverMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/16/2012 01:55'!
receivers: aString
	|ob|
	ob := self new.
	ob receiverNames: aString;
		cleanFromCharacteres.
	^ob.
	! !

!PhReceiverMatcher methodsFor: 'parsing' stamp: 'MiguelCampusano 8/18/2012 22:41'!
cleanFromCharacteres
	
 	receiverNamesClean:= ((receiverNames subStrings: '+' )at:1). "if have to match subclass (+)"
	receiverNamesClean:= ((receiverNamesClean subStrings: ' ' )at:1). "if have to match metaclass (class)"! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/18/2012 23:48'!
getAllReceiversThatMatch

	|classes|
 
	self ifNeedToMatchSubclass
		ifTrue:[classes := self getClassAndSubclassThatMatch]
		ifFalse:[classes := self getClassesThatMatch.].
	
	self ifNeedToMatchMetaclass
		ifTrue:[^classes collect:[:aClass| aClass class]]
		ifFalse:[^classes].
	! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'mcamp 11/7/2012 02:31'!
getClassAndSubclassThatMatch
	"return all classes that matches receiverName"

	|matchesClasses matchesClassesSubclasses|
	
	matchesClassesSubclasses := Set new.
	matchesClasses := self getClassesThatMatch.
	matchesClassesSubclasses addAll: matchesClasses.
	matchesClassesSubclasses addAll: (self getRestrictionClasses select: [:aClass| PhReceiverMatcher class: aClass inheritsFromClassIn: matchesClasses]).
	
	^matchesClassesSubclasses.  ! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/16/2012 00:37'!
getClassesThatMatch

	 ^self getRestrictionClasses select: [:aClass| self matchesWithoutSubclasses: aClass asString.]! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:41'!
getRestrictionClasses

	|cls|
	cls := withinClasses isNil 
		ifTrue: [Smalltalk allClasses]
		ifFalse: [withinClasses].
		
	^ self takeOutClasses: cls! !

!PhReceiverMatcher methodsFor: 'testing' stamp: 'MiguelCampusano 8/18/2012 22:38'!
ifNeedToMatchMetaclass

	^'* class*' match: receiverNames
	

	! !

!PhReceiverMatcher methodsFor: 'testing' stamp: 'MiguelCampusano 8/16/2012 01:39'!
ifNeedToMatchSubclass

	^'*+' match: receiverNames
		
	! !

!PhReceiverMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/19/2012 19:55'!
matchesWithoutSubclasses: aReceiverName
	"return true if receiverNames match a aReceiverName. 
	In our regular expressions a '*' mean '.' in a normal regular expressions"

	|newRegExp|
	newRegExp := receiverNamesClean copyWithRegex: '\*' matchesReplacedWith: '.*'.
	^ aReceiverName matchesRegex: newRegExp. ! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 00:49'!
receiverNames
	^ receiverNames! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:38'!
receiverNames: aString
	receiverNames := aString.! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:12'!
receiverNamesClean
	^ receiverNamesClean! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/16/2012 01:12'!
receiverNamesClean: anObject
	receiverNamesClean := anObject! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:42'!
restrictedPackages
	|packages|
	
	packages := OrderedCollection new.
	self withoutPackages ifNil: [^packages].
	
	self withoutPackages do:[:prefix|
		packages addAll: (PackageInfo allPackages select: [ :e | e packageName beginsWith:prefix])
	].

	^packages.! !

!PhReceiverMatcher methodsFor: 'private' stamp: 'mcamp 1/20/2013 19:49'!
takeOutClasses: aList
	|classes newClasses|
	
	classes := OrderedCollection new.
	self restrictedPackages do:[:pckg|  classes addAll: (pckg classes collect:[:cls| cls asString])].
	newClasses := aList select:[:cls|
		(classes includes: cls asString) not.	
	].

	^newClasses.! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 01:37'!
withinClasses
	^ withinClasses! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 01:37'!
withinClasses: aList
	withinClasses := aList! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:28'!
withoutPackages
	^ withoutPackages! !

!PhReceiverMatcher methodsFor: 'accessing' stamp: 'mcamp 1/20/2013 19:28'!
withoutPackages: anArray
	withoutPackages := anArray! !

Object subclass: #PhSelectorMatcher
	instanceVariableNames: 'selectorNames withinClasses inMetaclass negation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Casper-Core'!

!PhSelectorMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/14/2012 02:48'!
receivers: aListOfClasses selectors: aSelector
	^ self new 
		withinClasses: aListOfClasses; 
		selectorNames: aSelector.! !

!PhSelectorMatcher class methodsFor: 'instance creation' stamp: 'MiguelCampusano 8/14/2012 02:39'!
selectors: aString
	^ self new selectorNames: aString.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 03:44'!
getAllLocalMethodsThatMatchOfClass: aClass
	"consider all methods in aClass an it superclass"
	|selectors|
	selectors := OrderedCollection new.
	
	selectorNames ifNil:[^selectors].
	selectorNames isEmpty ifTrue:[^ aClass methods].
	selectors addAll: (aClass methods select: [:aMethod| self matches: aMethod selector asString]).
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'mcamp 1/3/2013 03:44'!
getAllMethodsThatMatchOfClass: aClass
	"consider all methods in aClass an it superclass"
	|selectors|
	selectors := OrderedCollection new.
	
	selectorNames ifNil:[^selectors].
	selectorNames isEmpty ifTrue:[^ aClass allMethods].
	selectors addAll: (aClass allMethods select: [:aMethod| self matches: aMethod selector asString]).
	
	^selectors.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/15/2012 23:31'!
inMetaclass
	^ inMetaclass! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/15/2012 23:31'!
inMetaclass: anObject
	inMetaclass := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'mcamp 9/23/2012 19:10'!
matches: aSelectorString
	"return true when a selector in selectorNames matches aSelectorString "

	selectorNames isString 
		ifTrue:[
			^ self regExp: selectorNames matches: aSelectorString	
		]
		ifFalse: [
			selectorNames do:[:s|
				(self regExp: s matches: aSelectorString) ifTrue:[^true].
			].
		].
	^false.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:15'!
negation
	^ negation! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/19/2012 19:15'!
negation: anObject
	negation := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'mcamp 9/23/2012 19:06'!
regExp: aRegExp matches: aSelectorString 
	"return true if aRegExp match aSelectorString. 
	In our regular expressions a '_' mean that matches any word in a method name.
	ie: #methodname: 'bar:baz:' matches: 'bar:_:' 			-- true"

	|collectMethod collectRegExp|
				
	((aSelectorString matchesRegex: '.*\:') xor: (aRegExp matchesRegex: '.*\:')) ifTrue: [^false].

	collectMethod := aSelectorString subStrings: ':'.
	collectRegExp := aRegExp subStrings: ':'.
	collectMethod size = collectRegExp size ifFalse: [^false].

	collectMethod with: collectRegExp do: [:a :b| (self singleSelector: a matches: b) ifFalse: [^false]].
	 ^true.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
selectorNames
	^ selectorNames! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
selectorNames: anObject
	selectorNames := anObject! !

!PhSelectorMatcher methodsFor: 'matching' stamp: 'MiguelCampusano 8/14/2012 02:05'!
singleSelector: aSelectorName matches: aRegExp
	"return true if aRegExp match single methodName"

	|newRegExp|
	
	newRegExp := aRegExp.
	aRegExp = '_' ifTrue: [newRegExp := aRegExp copyWithRegex: '_' matchesReplacedWith: '\w+'].

	^aSelectorName matchesRegex: newRegExp.! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
withinClasses
	^ withinClasses! !

!PhSelectorMatcher methodsFor: 'accessing' stamp: 'MiguelCampusano 8/14/2012 02:17'!
withinClasses: anObject
	withinClasses := anObject! !
PhAspectWeaver initialize!
